//+------------------------------------------------------------------+
//|                                                       Nick 2.mq4 |
//|                                    Copyright  2010, Nick Masman |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Nick Masman"

//Trade Externs
extern int TrailBy = 35;
bool BarsStopLoss = true;
extern int StopLossBars = 10;
extern int BarsStopExtend = 35;
extern bool TrailStopLoss = true;
extern bool TrailAfterBreakeven = true;
extern bool UseTakeProfit = false;
extern int TakeProfitSize = 60;
extern bool UseDynamicLotSize = true;
extern double MaxRiskPercent = 2;
extern double FixedLotSize = 0.1;

double LotSize = 0.1;

//Small Trend Externs
extern int FFastEMAPeriod = 10;
extern int FSlowEMAPeriod = 20;

//Large Trend Externs
extern int FastEMAPeriod = 60;
extern int SlowEMAPeriod = 65;
extern int SlopeEMAPeriod = 20;
extern bool UseDivergence = true;
extern bool UseSlopeEMA = true;


//Multipliers
extern int TrendPeriodMultiplier = 4;

extern int MagicNumber = 1337;
extern int Slippage = 5;

//INDICATOR BUFFERS]

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
int StopLossSize = TrailBy;
  
int CalcDigits = MarketInfo(Symbol(),MODE_DIGITS);
double PipSize = 0.0001;
if(CalcDigits == 2 || CalcDigits == 3) 
   {
      PipSize = 0.01;
   }
else if(CalcDigits == 4 || CalcDigits == 5)
   {
      PipSize = 0.0001;
   }

   
double StopLossUse = StopLossSize * PipSize;
NormalizeDouble(StopLossUse, CalcDigits);
double TakeProfitUse = TakeProfitSize * PipSize;
NormalizeDouble(TakeProfitUse, CalcDigits);

//----
//TREND INDICATORS
RefreshRates();
double FastEMACurrent = iMA(NULL,0,(FastEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,0);
double FastEMAPrevious = iMA(NULL,0,(FastEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);
   
double SlowEMACurrent = iMA(NULL,0,(SlowEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,0);
double SlowEMAPrevious = iMA(NULL,0,(SlowEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);
   
double SlopeEMACurrent = iMA(NULL,0,(SlopeEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,0);
double SlopeEMAPrevious = iMA(NULL,0,(SlopeEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);
   
double CurrentEMASpread = MathAbs(FastEMACurrent-SlowEMACurrent);
double PreviousEMASpread = MathAbs(FastEMAPrevious-SlowEMAPrevious);

   
for(int Counter = 0; Counter < Bars; Counter++)
   {
      ObjectCreate("FastTrendEMA", OBJ_TREND, 0, (iTime(NULL,0,Counter)), (iMA(NULL,0,(FastEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,Counter)), (iTime(NULL,0,Counter+1)), (iMA(NULL,0,(FastEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,Counter+1)));
   }
     
//CHECK TO SEE IF FAST/SLOW EMAS ARE DIVERGING
bool Divergence = false;
   if(CurrentEMASpread > PreviousEMASpread)
      {
        Divergence = true;
      }
      else Divergence=false;

//SETTING THE TREND VARIABLE BASED ON EMA CONDITIONS
int Trend = 0;
      if((FastEMACurrent > SlowEMACurrent) && (Divergence == true || UseDivergence == false) && ((SlopeEMACurrent > SlopeEMAPrevious) || UseSlopeEMA == false))
         {
            Trend = 1;
         }
      else if((FastEMACurrent < SlowEMACurrent) && (Divergence == true || UseDivergence == false) && ((SlopeEMACurrent < SlopeEMAPrevious) || UseSlopeEMA == false))
         {
            Trend = -1;
         }
      else
         {
            Trend = 0;
         }

RefreshRates();
double FFastEMACurrent = iMA(NULL,0,(FFastEMAPeriod),0,MODE_EMA,PRICE_WEIGHTED,0);
double FFastEMAPrevious = iMA(NULL,0,(FFastEMAPeriod),0,MODE_EMA,PRICE_WEIGHTED,1);
   
double FSlowEMACurrent = iMA(NULL,0,(SlowEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,0);
double FSlowEMAPrevious = iMA(NULL,0,(SlowEMAPeriod*TrendPeriodMultiplier),0,MODE_EMA,PRICE_WEIGHTED,1);

int EMACross = 0;
      if((FFastEMACurrent > FSlowEMACurrent) && (FFastEMAPrevious < FSlowEMAPrevious))
         {
            EMACross = 1;
         }
      else if((FFastEMACurrent < FSlowEMACurrent) && (FFastEMAPrevious > FSlowEMAPrevious))
         {
            EMACross = -1;
         }
      else EMACross = 0;

//COUNT ALL ORDERS TO HAVE ONLY 1 OPEN AT A TIME
int OrderCounter = 0;

   for(Counter = 0; Counter <= OrdersTotal()-1; Counter++)
      {
         bool SelectOrder = OrderSelect(Counter,SELECT_BY_POS);
         //using LongtEntryCalc to calculate new lot sizes for order modification. Entry only moves towards price.
         if(OrderMagicNumber() == MagicNumber)
            {
               OrderCounter++;
            }
      }
      
int ShortStopLossShift = iHighest(NULL,0,MODE_HIGH,StopLossBars,0);      
int LongStopLossShift = iLowest(NULL,0,MODE_LOW,StopLossBars,0);     
 
//CALCULATE LOT SIZE
RefreshRates();

double MaxRiskDollars = AccountEquity() * (MaxRiskPercent/100);
double TickValue = MarketInfo(Symbol(), MODE_TICKVALUE);
if(Digits == 3 || Digits == 5) TickValue *= 10;

double LongRiskPips = ((BarsStopExtend) + ((Ask - Low[LongStopLossShift])/PipSize));
double LongLotSize = (MaxRiskDollars / LongRiskPips) / TickValue;
double ShortRiskPips = ((BarsStopExtend) + ((Bid + High[ShortStopLossShift])/PipSize));
double ShortLotSize = (MaxRiskDollars / ShortRiskPips) / TickValue;

if(UseDynamicLotSize == false)
   {
      LongLotSize = FixedLotSize;
      ShortLotSize = FixedLotSize;
   }
else if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)
   {  
      LongLotSize = NormalizeDouble(LongLotSize,1);
      ShortLotSize = NormalizeDouble(ShortLotSize,1);
   }
else
   {
      LongLotSize = NormalizeDouble(LongLotSize,2);
      ShortLotSize = NormalizeDouble(ShortLotSize,2);
   }
   
if(LongLotSize < MarketInfo(Symbol(), MODE_MINLOT))
   {  
      LongLotSize = MarketInfo(Symbol(), MODE_MINLOT);
   }
if(ShortLotSize < MarketInfo(Symbol(), MODE_MINLOT))
   {  
      ShortLotSize = MarketInfo(Symbol(), MODE_MINLOT);
   }

//Print("Equity = ",AccountEquity(),". MaxRisk = ",MaxRiskDollars,". LongRiskPips = ",LongRiskPips,". LongLotSize = ",LongLotSize);
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//BUY AND SELL ORDERS 
   if((OrderCounter == 0) && (LotSize != 0))
      {
         if((Trend == 1) && (EMACross == 1))
            {
               RefreshRates();
               if(BarsStopLoss == true)
                  {
                     double LongStopLossLevel = Low[LongStopLossShift] - (BarsStopExtend * PipSize);
                     NormalizeDouble(LongStopLossLevel, CalcDigits);
                  }
               else LongStopLossLevel = NormalizeDouble((Ask - StopLossUse), CalcDigits);
               
               if(UseTakeProfit == false)
                  { 
                     double LongTakeProfitLevel = 0;
                  }
               else LongTakeProfitLevel = NormalizeDouble((Ask + TakeProfitUse), CalcDigits);
               
               int BuyTicket = OrderSend(Symbol(),OP_BUY,LongLotSize,Ask,Slippage,LongStopLossLevel,LongTakeProfitLevel,"Buy Order",MagicNumber,0,Green);
               Print("Attempted Buy order, Ticket: ",BuyTicket,". StopLoss: ",LongStopLossLevel,". Ask: ",Ask,". TakeProfit: ",LongTakeProfitLevel,". LongLotSize: ",LongLotSize);
            }
         if((Trend == -1) && (EMACross == -1))
            {
               RefreshRates();
               if(BarsStopLoss == true)
                  {
                     double ShortStopLossLevel = High[LongStopLossShift] + (BarsStopExtend * PipSize);
                     NormalizeDouble(ShortStopLossLevel, CalcDigits);
                  }
               else ShortStopLossLevel = NormalizeDouble((Bid + StopLossUse), CalcDigits);
               
               if(UseTakeProfit == false)
                  { 
                     double ShortTakeProfitLevel = 0;
                  }
               else ShortTakeProfitLevel = NormalizeDouble((Bid - TakeProfitUse), CalcDigits);
               
               int SellTicket = OrderSend(Symbol(),OP_SELL,ShortLotSize,Bid,Slippage,ShortStopLossLevel,ShortTakeProfitLevel,"Sell Order",MagicNumber,0,Green);
               Print("Attempted Sell order, Ticket: ",BuyTicket,". StopLoss: ",ShortStopLossLevel,". Ask: ",Ask,". TakeProfit: ",ShortTakeProfitLevel,". ShortLotSize: ",ShortLotSize);
            }
      }
      
      
      
for(Counter = 0; Counter <= OrdersTotal()-1; Counter++)
   { 
      OrderSelect(Counter, SELECT_BY_POS);
      
      double MaxLongStopLoss = MarketInfo(Symbol(),MODE_BID) - StopLossUse;
      double MaxShortStopLoss = MarketInfo(Symbol(),MODE_ASK) + StopLossUse;
      
      MaxShortStopLoss = NormalizeDouble(MaxShortStopLoss, CalcDigits);
      MaxLongStopLoss = NormalizeDouble(MaxLongStopLoss, CalcDigits);
      
      double CurrentStop = NormalizeDouble(OrderStopLoss(), CalcDigits);
      
      //Modify Stops
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY && CurrentStop < MaxLongStopLoss && TrailStopLoss == true && (TrailAfterBreakeven == false || OrderOpenPrice() < MaxLongStopLoss))
         {
            bool LongTrailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxLongStopLoss,OrderTakeProfit(),0);
         }
      if(OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL && CurrentStop > MaxShortStopLoss && TrailStopLoss == true && (TrailAfterBreakeven == false || OrderOpenPrice() > MaxShortStopLoss))
         {
            bool ShortTrailed = OrderModify(OrderTicket(),OrderOpenPrice(),MaxShortStopLoss,OrderTakeProfit(),0);
         }
   }
         
         
         
         
         
//----
   return(0);
  }
//+------------------------------------------------------------------+